;dekod.asm: 16f1612-re hangszerelt dekdol kzp

	list p=12f1612
	list r=dec
	#include <p12f1612.inc>
	#include <prlx.inc>

	__config _config1, _FOSC_INTOSC & _PWRTE_OFF & _MCLRE_OFF & _CP_OFF & _BOREN_ON & _CLKOUTEN_OFF
	__config _config2, _WRT_OFF& _ZCD_OFF& _PLLEN_ON& _BORV_LO& _STVREN_OFF& _LPBOR_OFF & _LVP_OFF
	__config _config3, _WDTCPS_WDTCPS1F & _WDTE_OFF & _WDTCWS_WDTCWSSW & _WDTCCS_SWC
	
; a 2 s fl bjtnyi cm hexadecimlis alakban 3 bjton, balra igaztva,
; ezt kell az adhoz igazitva megadni:
	
addr	equ	0x279f20    ; FORDITS ELTT A TNYLEGESRE CSERLNI!!!!!!!!!!
	
; az sszehasonlit bjtokat forditskor legyrtja belle:
cim0	equ	addr >>23&0xff	;0  
cim1	equ	addr >>15&0xff ;4fh	; 
cim2	equ	addr >>7&0xff ;
cim3	equ	addr <<1&0xff ;40h	; 
; A program vltozi: 
	cblock	0x20
	t2ofc		; t2 a nullson van
	pul2ses		; visszaszmll villogshoz
	endc		
	cblock	0x70
	range		; id?ablak sorszma
	bufuh		; bitsorozat legeslegfels
	bufu
	bufh
	bufl
	puuh		; pulzushossz ment
	puu
	puh
	pul
	msg		; zenetszmll
	bits		; bitszmll
	oldin		; elz kd
	newin		; aktulis kd
	aux		; ltalnos segdregiszter
	t6ofc		; szmll a hiba LED-hez
	flags	; vegyes jelzbitek
	endc
#define	vesz	flags,0
#define	van	flags,2

	org	0
	goto	start
	org	4
	banksel	0
	snb	pir4,smt1pwaif
	call	smt1pwir
	snb	pir4,smt1if
	call	smt1ir
	snb	pir4,smt1praif
	call	smt1ppir
	snb	pir1,tmr2if
	call	tmr2ir
	snb	pir2,tmr4if
	call	tmr4ir
	retfie

start
	banksel	osccon	; oscini
	movlw	70h
	movwf	osccon
	clrf	osctune 
	banksel	lata	; pinini
	clrf	lata
	banksel	trisa
	movlw	3ah	
	movwf	trisa
	banksel	ansela
	movlw	1
	movwf	ansela
	banksel	wpua
	movlw	28h
	movwf	wpua
	banksel	option_reg
	bcf	option_reg,7
 	banksel	smt1stat	; smt1ini
	movlw	83h
	movwf	smt1con0
	movlw	42h
	movwf	smt1con1
	clrf	smt1stat
	movlw	1
	movwf	smt1clk
	clrf	smt1win
	clrf	smt1sig
	clrf	smt1pru
	movlw	32h
	movwf	smt1prh
	movlw	0c8h
	movwf	smt1prl
	banksel	pie4
	bsf	pie4,smt1ie
	bsf	pie4,smt1pwaie
	bsf	pie4,smt1praie
	call	t2ini	; nem indul
	call	t4ini	; nem indul, megszakthat
	call	t6ini	; indul, nem szakt meg (kimarads)
	banksel	0
	clrf	t2ofc
	clrf	range
	clrf	bufuh
	clrf	bufu
	clrf	bufh
	clrf	bufl
	clrf	puuh
	clrf	puu
	clrf	puh
	clrf	pul
	clrf	bits
	clrf	msg
	movlw	15
	movwf	oldin
	movwf	newin
	clrf	aux
	clrf	flags
	banksel	smt1con1
	bsf	smt1con1,smt1go	; smt1 elstartolhat
; timer2 mg vrakozik, smt1-gyel felvltva aktv    
	banksel	dac1con0	; dac1ini
	movlw	0xa0
	movwf	dac1con0
	movlw	8
	movwf	dac1con1    ; ezt 0-nak illik digitalizlni, kis o lesz
	banksel	0
	bsf	intcon,peie
	bsf	intcon,gie
main			    ; csak a kimaradst rzkeli, minden ms a megsz.
	banksel	pir2
	jnb	pir2,tmr6if,main
	bcf	pir2,tmr6if
	banksel	0
	decfsz	t6ofc,f
	goto	main
	banksel	dac1con1
	movlw	0f8h	    ; 
	movwf	dac1con1
	banksel	lata
	bsf	lata,2
	goto	main

smt1pwir
	bcf	pir4,smt1pwaif	; flag elintzve
	bcf	pir4,smt1praif	; az elz maradka lehet
	banksel	smt1con0
	movf	smt1cpwu,w
	movwf	puu
	movf	smt1cpwh,w
	movwf	puh
	movf	smt1cpwl,w
	movwf	pul		; munkaregiszterekbe trakva
	banksel	0
	movlw	80h
	movwf	range		; ha puu nem 0,range=80h
	movf	puu,f
	snz
	clrf	range		; egybknt nullrl indul, hibval
	movlw	low	170 ;296
	movwf	aux
	movlw	high	170 ;296
	call	cmp2
	snc
	incf	range,f		; j nulla 170-344
	movlw	low	344
	movwf	aux
	movlw	high	344
	call	cmp2
	snc
	incf	range,f		; nullnak hossz
	movlw	low	810 ;888
	movwf	aux
	movlw	high	810 ;888
	call	cmp2
	snc
	incf	range,f		; j 1 888-1032
	movlw	low	1032
	movwf	aux
	movlw	high	1032
	call	cmp2
	snc
	incf	range,f		; 1-nek hossz >1032
	snb	range,7
	goto	abort
	sb	range,0
	goto	abort
; ha j, akkor vesz=1, bits=bits+1, s a bit belp buf:4 aljn,
; range tnkremegy
	banksel	lata
	snb	range,1
	bsf	lata,1
	banksel	porta
	incf	bits,f
	bsf	vesz
	rrf	range,f
	rrf	range,f
	rlf	bufl,f
	rlf	bufh,f
	rlf	bufu,f
	rlf	bufuh,f
	banksel	0
	return

smt1ppir		
	bcf	pir4,smt1praif	; flag elintzve
	sb	vesz
	return		; ha nem vesz, rdektelen
	banksel	smt1con0
	movf	smt1cpru,w
	movwf	puu
	movf	smt1cprh,w
	movwf	puh
	movf	smt1cprl,w
	movwf	pul		; peridusid a munkaregiszterben
	banksel	0
	movlw	80h
	movwf	range
	movf	puu,f
	snz
	clrf	range		; peridusnak rvid
	movlw	low	1184
	movwf	aux
	movlw	high	1184
	call	cmp2
	snc
	incf	range,f		; j peridus (1280)
	movlw	low	1376
	movwf	aux
	movlw	high	1376
	call	cmp2
	snc
	incf	range,f		; szinkronnak rvid
	movlw	low	9472
	movwf	aux
	movlw	high	9472
	call	cmp2
	snc
	incf	range,f		; j szinkron
	movlw	low	11008
	movwf	aux
	movlw	high	11008
	call	cmp2
	snc
	incf	range,f		; szinkronnak hossz, de jtt felfut
	jb	range,7,abort
	movf	range,w
	andlw	7
	brw
	goto	abort
	goto	jobit
	goto	abort
	goto	josync
	goto	abort
	nop
	nop
	goto	abort
; ennek nemcsak az abort kell hanem a jobit s a josync is.
jobit
	return
josync
	cjnel	bits,25,abort
	clrf	bits
	incf	msg,f
	;movf	bufuh,f	; korltozott rvny? volt
	;sz
	;goto	abort
	cjnel	bufuh,cim0,abort    ; gy univerzlis (kezd?dhet 1-gyel)
	cjnel	bufu,cim1,abort
	cjnel	bufh,cim2,abort
;	call	setled
	movf	bufl,w
	andlw	0e0h
	xorlw	cim3
	sz
	goto	abort
;	call	setled
; bejtt a komplett zenet j cmmel, bufl als 5 bitjn kd + 0.
; fel kell dolgozni (hnyadik?) Ha els, nincs mivel sszehasonltani.
	rrf	bufl,w
	andlw	0fh
	movwf	newin
	xorwf	oldin,w
	snz
	bsf	van
;	snb van
;	call	setled
	movf	newin,w
	movwf	oldin
	return		;  nem adja le, majd a zrs
; smt1 tfordult: az zenetblokk befejezdtt, mr ha vett valamit.
; ha vett, ads s knyszersznet,t6ofc trlse
smt1ir
	bcf	pir4,smt1if
	sb	van
	goto	abort
	clrf	msg
	clc
	rlf	oldin,w
	addlw	2
	movwf	pul2ses
	banksel	t4con
	clrf	tmr4
	bsf	t4con,tmr4on
	banksel	lata
	bcf	lata,2
	banksel	dac1con1
	swapf	oldin,w		; a fels 4 bitre
	bsf	wreg,3		; a tartomny kzepre
	movwf	dac1con1
	banksel	smt1con1
	bcf	smt1con1,smt1go	; smt1 lell
	banksel	t2con
	clrf	tmr2
	bsf	t2con,tmr2on	; t2 indul
	bcf	vesz
	bcf	van
	movlw	3
	movwf	t2ofc
	movlw	13
	movwf	t6ofc
	return
tmr2ir				; 48 s bke j vtel jutalmaknt
	bcf	pir1,tmr2if
	decfsz	t2ofc,f
	return
	bcf	t2con,tmr2on	; t2 lell
	banksel	smt1con1
	bsf	smt1con1,smt1go	; smt1 indul
	banksel	0
	return
; ha jtt valami, elvillogja	
tmr4ir
	banksel	0
	bcf	pir2,tmr4if
	banksel	lata
	movlw	4
	xorwf	lata,f
	banksel	0
	decfsz	pul2ses
	return
	banksel	t4con
	bcf	t4con,tmr4on
	clrf	tmr4
	banksel	0
	return
; van az abort (minden g trlte a sajt flagjt)
abort
	clrf	bufuh
	clrf	bufu
	clrf	bufh
	clrf	bufl
	clrf	bits
	clrf	msg
	clrf	newin
	banksel	0
	bcf	vesz
	banksel	lata
	bcf lata,1
	banksel	porta
	return
; s persze van mg ez a rutin:
cmp2
	subwf	puh,w
	sz
	return
	movf	aux,w
	subwf	pul,w
	return
; a hrom timer2 jelleg szmll inicializlsa		
t2ini		; nem indul, de krhet megszakitst
	banksel	t2con	
	movlw	7fh
	movwf	t2con
	movlw	5
	movwf	t2clkcon
	clrf	t2hlt
	clrf	t2rst
	movlw	0xf3
	movwf	t2pr
	clrf	tmr2
	banksel	pir1
	bcf	pir1,tmr2if
	banksel	pie1
	bsf	pie1,tmr2ie;
	return
	
t4ini		; nem indul, de krhet megszakitst
	banksel	t4con	
	movlw	69h
	movwf	t4con
	clrf	t4hlt
	clrf	t4rst
	movlw	0x9b
	movwf	t4pr
	clrf	tmr4
	banksel	pir1
	bcf	pir2,tmr4if
	banksel	pie1
	bsf	pie2,tmr4ie;
	return
t6ini				; nem kr megszaktst
	banksel	t6con	
	movlw	7fh
	movwf	t6con
	movlw	5
	movwf	t6clkcon
	clrf	t6hlt
	clrf	t6rst
	movlw	0xf3
	movwf	t6pr
	clrf	tmr6
	bsf	t6con,tmr6on	; indul
	banksel	pir2
	bcf	pir2,tmr6if
	banksel	0
	movlw	13		; timeout 9 kr mlva (> 2 perc)
	movwf	t6ofc
	return

setled
	banksel lata
	bsf lata,2
led
	banksel	0
	return
rstled
	banksel	lata
	bcf lata,2
	goto	led
setsig
	banksel lata
	bsf lata,1
	goto	led
rstsig
	banksel	lata
	bcf lata,1
	goto	led
	
	end;
	